
function [auc] = gretna_hub_auc(Rmatrix, s1,s2,deltas)

% function  [auc] = gretna_hub_auc(Rmatrix, s1,s2,deltas)
% example:
%  1.
%   [auc] = gretna_hub_auc(Rmatrix, 0.1,0.4,0.02)
% Yong HE, BIC

thresh_s = s1:deltas:s2;
NT = length(thresh_s);
NR = length(Rmatrix);
auc.thresh_s = thresh_s;


for i =1:NT
    [bmatrix,r] = gretna_R2b(Rmatrix, 's',thresh_s(i));
    eff=gretna_efficiency(bmatrix);
    reg_eff(i,:) = (eff.regionalglobalE/sum(eff.regionalglobalE))';
    %         reg_eff(i,:) = (eff.regionallocalE/sum(eff.regionallocalE))';
end

for i=1:NR
    tmp = reg_eff(:,i);
    auc.areg_eff(i,1) =  (sum(tmp) - mean(tmp([1 end])))*deltas;
end

