function [meancorr mincorr] = gretna_jacknifecorr(x)
% function [meancorr mincorr] = gretna_jacknifecorr(x)
% x: n*m       n: the number of time points
%                  m: the number of variables
% Yong HE



[n m] = size(x);

for i = 1:n
    data = x;
    data(i,:) = [];
    [tmpr(:,:,i) tmpp] = corrcoef(data);
end

meancorr = mean(tmpr,3);

for i = 1:m
    for j = 1:m
        if min(tmpr(i,j,:)) > 0
            mincorr(i,j) = min(tmpr(i,j,:));
        elseif max(tmpr(i,j,:)) < 0
            mincorr(i,j) = max(tmpr(i,j,:));
        else
            mincorr(i,j) = mean(tmpr(i,j,:));
        end
    end
end
