function [lobe_thickness] = gretna_lobethickness(M_left, vertex_label_left, M_right, vertex_label_right)
%
% function [lobe_thickness] = ...
%               gretna_lobethickness(M_left, vertex_label_left, M_right, vertex_label_right)
%
% For example:
%       M_left, M_right: s*n matrix (cortical thickness).
%       vertex_label_left, vertex_label_right: n*1 matrix; (animal
%       parcellation)



vertex_ct_matrix_left = M_left;
vertex_ct_matrix_right = M_right;


lobelabel.R{1} =  [10     2    75   114     5     6     1 7]; %R. frontal
lobelabel.L{1} = [ 70    50    15     9    80    90    85 27]; %L. frontal
lobelabel.R{2} = [88    60    19    32   110]; % R. parietal
lobelabel.L{2} = [52    41   159    56    74]; %L. parietal
lobelabel.R{3} =  [145   130   140    26   165    99   125 4];%R.temporal
lobelabel.L{3} =  [61    64   164    62   119   196    18 108];%L. temporal
lobelabel.R{4} = [132    38    63    97   175	112];%R.occipital
lobelabel.L{4} =  [251    98   154    37    54	69];%L.occipital

for i =1:4
    lobemean.L(:,i) = mean(vertex_ct_matrix_left(:,find(ismember(vertex_label_left,lobelabel.L{i})'==1)),2);
    lobemean.R(:,i) = mean(vertex_ct_matrix_right(:,find(ismember(vertex_label_right,lobelabel.R{i})'==1)),2);
end

lobe_thickness = [ lobemean.L  lobemean.R];
