function [lattice] = gretna_make_lattice(N,K)

% function [lattice] = gretna_make_lattice(N,K)
% N: the number of nodes; K : the number of edges
%
%  Yong HE, BIC, MNI, McGill 2007/05/01
% *************************************************************************


lattice = zeros(N,N);

sumK = N-1;
ntime = 1;
while sumK<K,
    sumK = sumK + N-1-ntime;
    ntime  = ntime+1;
end

ntime = ntime-1;
index = N-ntime;
for i =1:index
    for j = 1:ntime
        lattice(i,i+j) = 1;
    end
end

i=1;
while i<ntime
    lattice(index+i,index+i+1 :N)=1;
    i = i+1;
end

for i = 1:index-1
    loc (i,:) = [i i+ntime+1];end
rndindex = randperm(index-1);
leftK = K - sum(sum(lattice));
for i = 1:leftK
    lattice(loc(rndindex(i),1), loc(rndindex(i),2)) = 1;
end

lattice = lattice + lattice';



 