function [index, value] = fmri_matrixtotriu (a)
%function [index, value] = fmri_matrixtotriu (a)
% a     -   N*N matrix
% value -   one coloumn vector: triu triangular of matrix a
% index -   index of element in matrix a
% example
%  a = [ 0    0.6204    0.4303    0.5098    0.0504
%     0.6204         0    0.0602    0.1966    0.2273
%     0.4303    0.0602         0    0.7815    0.0359
%     0.5098    0.1966    0.7815         0    0.3672
%     0.0504    0.2273    0.0359    0.3672         0];
%   [index, b] = fmri_matrixtotriu(a)
%  b=[0.6204    0.4303    0.5098    0.0504    0.0602    0.1966...
%     0.2273    0.7815    0.0359    0.3672 ]';
% % index=[
%      1     2
%      1     3
%      1     4
%      1     5
%      2     3
%      2     4
%      2     5
%      3     4
%      3     5
%      4     5]



N = size(a,1);
len = 1;
for i = 1:N-1
    for j = i+1:N
        value(len,:) = a(i,j);
        index(len,:) = [i j];
        len = len + 1;
    end
end

