function [CIJ, N, leftNo, delNo] = gretna_maxclique(A)
% find a largest cluster in a graph G
N = size(A,1);
[lambda, D] = gretna_shortestpathlength(A);
CIJ = A;

if max(max(D))~=inf
    CIJ = A;
    delNo = [];
else
    for i = 1:N
        maxpath(i) = length(find(D(i,:) ==inf));
    end
    delNo = find(maxpath ~=  min(maxpath));
    delNotot = length(delNo);
    for i = 1:delNotot
        CIJ (delNo(delNotot-i+1),:)=[];
        CIJ (:,delNo(delNotot-i+1))=[];
    end
end

leftNo = 1:N;
leftNo(delNo) =[];

return

function  [lambda, D] = gretna_shortestpathlength(A);
%  the average path length of graph G 
A = A + diag(diag(A));
A(find(A==0)) = inf;
N = length(A);
D = A - diag(diag(A));

% Floyd-Warshall algorithm 
for i = 1:N
  k = setdiff((1:N),i);
  D(k,k) = min(D(k,k),repmat(D(k,i),1,N-1) + repmat(D(i,k),N-1,1));
end

for i = 1:N
    D(i,i) =0;
end

D = triu(D);
lambda = sum(sum(D(D~=inf)))/(N*(N-1)/2);
D = D + D';

return

