function [R] = gretna_parcorr(A)
% *************************************************************************
%   fmri_ParCorr: Partial Correlation Matrix
%   [R] = gretna_parcorr(A) 
%   Input:
%       A   - each row is an observation and each column is  a variable. 
%              Namely, A is a matrix of column vectors (i.e. A = [A1 A2 ... An]
%              where An is a column vector).
%   Output:
%       R   - partial correlation matrix
%
%   He Yong, BIC,MNI,McGill
%   2007/02/01
% *************************************************************************


if nargin >= 2  
    error('error input parameters.');end

B = inv(cov(A));

R = zeros(size(B));
for i = 1:size(B,1)
  for j = 1:size(B,2)
    R(i,j) = - B(i,j) / sqrt(B(i,i) * B(j,j));
  end
end