


function [av, matrix] = gretna_read_gmd(subject_gmd_data_file);
% input:
%       subject_gmd_data_file: text file includig the pet data path
%               + filename of each subject
% ouput:
%           av: the avearage value (pet measurement) of each subject
%           matrix: n*m; n:the number of subjects; m: the number of BA area
%           (41)
%
%  example:
%        [av, matrix] = gretna_read_gmd('/data/aces/aces1/yonghe/icbm/subject_gmd_data');
% Yong HE




jacoblabel = '/data/aces/aces1/yonghe/gretna/labels.txt';
atlasfile = '/data/aces/aces1/yonghe/icbm/jakob_icbm_t1tal_fineatlas_update.mnc';

d_atlas = fmris_read_minc(atlasfile,1:181,1);
label = load (jacoblabel);
label

data_file = textread(subject_gmd_data_file,'%s');
nSub = size(data_file,1)
data_file

for i = 1:nSub
    fprintf('\ni = %d\n',i);
    d = fmris_read_minc(cell2mat(data_file(i,:)),1:181,1);
    data = d.data;
    av(i,1) = sum(sum(sum(data)))/ length(find(data~=0));
    for j = 1:length(label)
        fprintf('.');
        matrix(i,j) = mean(data(find(d_atlas.data == label(j))));
    end
    fprintf('done\n')
end
