


function [av, matrix] = gretna_read_pet(subject_pet_data_file);
% input: 
%       subject_pet_data_file: text file includig the pet data path
%               + filename of each subject
% ouput:
%           av: the avearage value (pet measurement) of each subject
%           matrix: n*m; n:the number of subjects; m: the number of BA area
%           (41)
%        
%  example:
%        [av, matrix] = gretna_read_pet('/data/aces/aces1/yonghe/pedro_pet_data/prog/subject_pet_data');
% Yong HE




BAareaLabel = '/data/aces/aces1/yonghe/pedro_pet_data/prog/BAareaLabel';
brodfile = '/data/aces/aces1/yonghe/pedro_pet_data/prog/brodmann.img';
d_brod = fmris_read_analyze(brodfile);
mask = zeros(d_brod.dim(1),d_brod.dim(2),d_brod.dim(3));
mask(find(d_brod.data~=0))=1;
numvox = length(find(mask==1))

BAarea = textread(BAareaLabel,'%d');
BAarea
petdata_file = textread(subject_pet_data_file,'%s');
nSub = size(petdata_file,1)
petdata_file

% left and right hemisphere BA areas:
for i = 1:181
if i>=91
d_brod.data (i,:,:) = d_brod.data(i,:,:)+100;
end
end


for i = 1:nSub
    fprintf('\ni = %d\n',i);
    d_pet = fmris_read_minc(cell2mat(petdata_file(i,:)),1:181,1);

    mask = zeros(d_pet.dim(1),d_pet.dim(2),d_pet.dim(3));
    mask(find(d_pet.data~=0))=1;
    numvox = length(find(mask==1));
    d_brod.data = d_brod.data.*mask;

    data = d_pet.data;
    av(i,1) = sum(sum(sum(data)))/numvox;
    for j = 1:length(BAarea)
        fprintf('.');
        matrix(i,j) = mean(data(find(d_brod.data == BAarea(j))));
    end
    fprintf('done\n')
end
