


function [av_overall, av_ROI] = gretna_read_seedgmd(subject_gmd_data_file,seed,D);
% input:
%       subject_gmd_data_file: text file includig the pet data path
%               + filename of each subject
%        seed: voxel coordinate: e.g. [85 77 112]
%           D: diameter around the seed voxel.
% ouput:
%           av_overall: the avearage value (gmd measurement) of each subject
%           av_ROI: the avearage value within ROI (gmd measurement) of each subject
%            
%
%  example:
%        [av, matrix] = gretna_read_seedgmd('/data/aces/aces1/yonghe/icbm/subject_gmd_data',[85 77 112],);
% Yong HE




roimask = gretna_make_ROImask(seed,D);
roi = reshape(roimask,181*217*181,1);


data_file = textread(subject_gmd_data_file,'%s');
nSub = size(data_file,1)
data_file

for i = 1:nSub
    fprintf('\ni = %d\n',i);
    file =cell2mat(data_file(i,:));
    d = fmris_read_minc(file,1:181,1);
    data = reshape(d.data,181*217*181,1);
    N = length(find(data~=0));
    av_overall(i,1) = sum(data)/ N;
    av_ROI(i,1) = mean(data(find(roi==255)));
    fprintf('done\n')
end
