function [vertex_label] = gretna_surfaceseg1(vertex_animalmidsurf)
% *************************************************************************
% This function is used to segment cortical surface (ANIMAL + INSECT)
%
%
% function [vertex_label_left, vertex_label_right] =
% gretna_surfaceseg(subjects_filename_ANIMAL_left, subjects_filename_ANIMAL_right)
%
%
% For example:
%
% ......
%
% input:
%
%
% output:
%           vertex_label_left: a labelled surface file of left hemisphere (.txt)
%           vertex_label_right: a labelled surface file of right hemisphere (.txt)
%
% Yong HE, BIC, MNI, McGill 2007/05/01
% *************************************************************************



warning off

vertex_label_matrix = floor(vertex_animalmidsurf');

[Max, vertex_label] = max(hist(vertex_label_matrix', 0:255));

vertex_label = vertex_label - ones(1,length(vertex_label));
size(vertex_label)
load labels.txt

t = ismember(vertex_label, labels);
%size(t)
vertex_label = (vertex_label .* t)';

%test

fprintf('Finished.\n')

return;
