function [Sparsity, LargeComp, Avedeg, Connectedness, PathLen, ClustCoff, Eff,rerand] =...
    gretna_swdiffinteraction_K(group1, group2, group3, group4, k1,k2,deltak, num_rand, brandnetwork)
%group1: Young_HI
%group2: Young_Low
%group3: Old_HI
%group4: Old_Low

if nargin < 4
    error('No parameters');end

if nargin == 4
    N1 = size(group1,2);
    k1=10; k2 = N1*(N1-1)/2; deltak = 10; num_rand = 400;end

if nargin == 8
    brandnetwork = 0;end

if nargin > 9
    error('The number of input parameters should be less than 7.'); end

N1 = size(group1,1);
N2 = size(group2,1);
N3 = size(group3,1);
N4 = size(group4,1);

N_tgroup13 = N1 + N3;
N_tgroup24 = N2 + N4;
tgroup13_Reg = [group1;group3];
tgroup24_Reg = [group2;group4];

R_matrix1 = corrcoef(group1);
R_matrix2 = corrcoef(group2);
R_matrix3 = corrcoef(group3);
R_matrix4 = corrcoef(group4);

N_region = size(R_matrix1,1);
R_matrix1 = abs(R_matrix1);
R_matrix2 = abs(R_matrix2);
R_matrix3 = abs(R_matrix3);
R_matrix4 = abs(R_matrix4);

R_matrix1 = R_matrix1 - diag(diag(R_matrix1));
R_matrix2 = R_matrix2 - diag(diag(R_matrix2));
R_matrix3 = R_matrix3 - diag(diag(R_matrix3));
R_matrix4 = R_matrix4 - diag(diag(R_matrix4));

% caluculate the Cp, Lp of nc, ad group at different average degree <K> and
% compare the between-group significance of Cp, Lp  by a randomized
% procedure

%  K = 150:10:600%298:4:1050;
%  K is the number of edges
K = k1:deltak:k2
Sparsity = 100*K/((N_region*(N_region-1))/2)


for m = 1:length(K)
    fprintf('\nm = %d\n',m);
    % Cp Lp in the group1
    R_matrixretmp1 = reshape(R_matrix1, N_region*N_region,1);
    [R_matrixrer1 R_matrixreindex1] = sort(R_matrixretmp1);
    R_matrixretmp1(R_matrixreindex1((end-(2*K(m)-1)):end)) = 1;
    R_matrixretmp1(R_matrixreindex1(1:(end-2*K(m)))) = 0;
    corrmatrix1 = reshape(R_matrixretmp1,N_region,N_region);
    if brandnetwork ==0
        [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix1,0,0);
    else
        [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix1,1,100);
        PathLen.Lambda1(m) = sw.Lambda;
        ClustCoff.Gamma1(m) = sw.Gamma;
    end
    Eff.gE1(m) = sw.gE; Eff.localE1(m) = sw.localE;
    PathLen.Lp1(m) = sw.Lp;  ClustCoff.Cp1(m) = sw.Cp;
    LargeComp.S1(m) = sw.LargestCompSize;
    Connectedness.Connect1(m) = sw.connectedness;
    Avedeg.avedeg1(m) =  degree.avedeg;

    % Cp Lp in the group2
    R_matrixretmp2 = reshape(R_matrix2, N_region*N_region,1);
    [R_matrixrer2 R_matrixreindex2] = sort(R_matrixretmp2);
    R_matrixretmp2(R_matrixreindex2((end-(2*K(m)-1)):end)) = 1;
    R_matrixretmp2(R_matrixreindex2(1:(end-2*K(m)))) = 0;
    corrmatrix2 = reshape(R_matrixretmp2,N_region,N_region);
    if brandnetwork ==0
        [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix2,0,0);
    else
        [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix2,1,100);
        PathLen.Lambda2(m) = sw.Lambda;
        ClustCoff.Gamma2(m) = sw.Gamma;
    end
    Eff.gE2(m) = sw.gE; Eff.localE2(m) = sw.localE;
    PathLen.Lp2(m) = sw.Lp;    ClustCoff.Cp2(m) = sw.Cp;
    LargeComp.S2(m) = sw.LargestCompSize;
    Connectedness.Connect2(m) = sw.connectedness;
    Avedeg.avedeg2(m) =  degree.avedeg;

    % Cp Lp in the group3
    R_matrixretmp3 = reshape(R_matrix3, N_region*N_region,1);
    [R_matrixrer3 R_matrixreindex3] = sort(R_matrixretmp3);
    R_matrixretmp3(R_matrixreindex3((end-(2*K(m)-1)):end)) = 1;
    R_matrixretmp3(R_matrixreindex3(1:(end-2*K(m)))) = 0;
    corrmatrix3 = reshape(R_matrixretmp3,N_region,N_region);
    if brandnetwork ==0
        [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix3,0,0);
    else
        [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix3,1,100);
        PathLen.Lambda3(m) = sw.Lambda;
        ClustCoff.Gamma3(m) = sw.Gamma;
    end
    Eff.gE3(m) = sw.gE; Eff.localE3(m) = sw.localE;
    PathLen.Lp3(m) = sw.Lp;  ClustCoff.Cp3(m) = sw.Cp;
    LargeComp.S3(m) = sw.LargestCompSize;
    Connectedness.Connect3(m) = sw.connectedness;
    Avedeg.avedeg3(m) =  degree.avedeg;

    % Cp Lp in the group4
    R_matrixretmp4 = reshape(R_matrix4, N_region*N_region,1);
    [R_matrixrer4 R_matrixreindex4] = sort(R_matrixretmp4);
    R_matrixretmp4(R_matrixreindex4((end-(2*K(m)-1)):end)) = 1;
    R_matrixretmp4(R_matrixreindex4(1:(end-2*K(m)))) = 0;
    corrmatrix4 = reshape(R_matrixretmp4,N_region,N_region);
    if brandnetwork ==0
        [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix4,0,0);
    else
        [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix4,1,100);
        PathLen.Lambda4(m) = sw.Lambda;
        ClustCoff.Gamma4(m) = sw.Gamma;
    end
    Eff.gE4(m) = sw.gE; Eff.localE4(m) = sw.localE;
    PathLen.Lp4(m) = sw.Lp;  ClustCoff.Cp4(m) = sw.Cp;
    LargeComp.S4(m) = sw.LargestCompSize;
    Connectedness.Connect4(m) = sw.connectedness;
    Avedeg.avedeg4(m) =  degree.avedeg;

    % a randomization procedure is used to detect the significance of the
    % difference of Cp Lp
    for i = 1: num_rand
        fprintf('-')
        rp = randperm(N_tgroup13);
        rerand_Reg1 = tgroup13_Reg(rp(1:N1),:);
        rerand_Reg2 = tgroup13_Reg(rp ((N1+1):N_tgroup13),:);
        rerand_corr_1 = corrcoef(rerand_Reg1);
        rerand_corr_2 = corrcoef(rerand_Reg2);
        rerand_corr_1 = abs(rerand_corr_1) ;
        rerand_corr_2 = abs(rerand_corr_2) ;

        rerand_corr_1 = rerand_corr_1 - diag(diag(rerand_corr_1));
        rerand_corr_2 = rerand_corr_2 - diag(diag(rerand_corr_2));

        R_matrixretmp = reshape(rerand_corr_1, N_region*N_region,1);
        [R_matrixrer R_matrixreindex] = sort(R_matrixretmp);
        R_matrixretmp(R_matrixreindex((end-(2*K(m)-1)):end)) = 1;
        R_matrixretmp(R_matrixreindex(1:(end-2*K(m)))) = 0;
        corrmatrix1 = reshape(R_matrixretmp,N_region,N_region);
        if brandnetwork ==0
            [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix1,0,0);
        else
            [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix1,1,100);
            rerand_Lambda1(i) = sw.Lambda;
            rerand_Gamma1(i) = sw.Gamma;
        end
        rerand_Lp1(i) = sw.Lp; rerand_Cp1(i) = sw.Cp;
        rerand_gE1(i) = sw.gE; rerand_localE1(i) = sw.localE;

        R_matrixretmp = reshape(rerand_corr_2, N_region*N_region,1);
        [R_matrixrer R_matrixreindex] = sort(R_matrixretmp);
        R_matrixretmp(R_matrixreindex((end-(2*K(m)-1)):end)) = 1;
        R_matrixretmp(R_matrixreindex(1:(end-2*K(m)))) = 0;
        corrmatrix2 = reshape(R_matrixretmp,N_region,N_region);
        if brandnetwork ==0
            [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix2,0,0);
        else
            [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix2,1,100);
            rerand_Lambda3(i) = sw.Lambda;
            rerand_Gamma3(i) = sw.Gamma;
        end
        rerand_Lp3(i) = sw.Lp;rerand_Cp3(i) = sw.Cp;
        rerand_gE3(i) = sw.gE; rerand_localE3(i) = sw.localE;
    end
    
 rp=[];
    rp = randperm(N_tgroup24);
        rerand_Reg1 = tgroup24_Reg(rp(1:N1),:);
        rerand_Reg2 = tgroup24_Reg(rp ((N1+1):N_tgroup24),:);
        rerand_corr_1 = corrcoef(rerand_Reg1);
        rerand_corr_2 = corrcoef(rerand_Reg2);
        rerand_corr_1 = abs(rerand_corr_1) ;
        rerand_corr_2 = abs(rerand_corr_2) ;

        rerand_corr_1 = rerand_corr_1 - diag(diag(rerand_corr_1));
        rerand_corr_2 = rerand_corr_2 - diag(diag(rerand_corr_2));

        R_matrixretmp = reshape(rerand_corr_1, N_region*N_region,1);
        [R_matrixrer R_matrixreindex] = sort(R_matrixretmp);
        R_matrixretmp(R_matrixreindex((end-(2*K(m)-1)):end)) = 1;
        R_matrixretmp(R_matrixreindex(1:(end-2*K(m)))) = 0;
        corrmatrix1 = reshape(R_matrixretmp,N_region,N_region);
        if brandnetwork ==0
            [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix1,0,0);
        else
            [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix1,1,100);
            rerand_Lambda2(i) = sw.Lambda;
            rerand_Gamma2(i) = sw.Gamma;
        end
        rerand_Lp2(i) = sw.Lp; rerand_Cp2(i) = sw.Cp;
        rerand_gE2(i) = sw.gE; rerand_localE2(i) = sw.localE;

        R_matrixretmp = reshape(rerand_corr_2, N_region*N_region,1);
        [R_matrixrer R_matrixreindex] = sort(R_matrixretmp);
        R_matrixretmp(R_matrixreindex((end-(2*K(m)-1)):end)) = 1;
        R_matrixretmp(R_matrixreindex(1:(end-2*K(m)))) = 0;
        corrmatrix2 = reshape(R_matrixretmp,N_region,N_region);
        if brandnetwork ==0
            [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix2,0,0);
        else
            [NN, KK,  aveden, degree, sw]  = gretna_sw(corrmatrix2,1,100);
            rerand_Lambda4(i) = sw.Lambda;
            rerand_Gamma4(i) = sw.Gamma;
        end
        rerand_Lp4(i) = sw.Lp;rerand_Cp4(i) = sw.Cp;
        rerand_gE4(i) = sw.gE; rerand_localE4(i) = sw.localE;
    end
    
    rerand_Lp12_34_diff = (rerand_Lp1-rerand_Lp2)-(rerand_Lp3-rerand_Lp4);
    rerand_Lp12_34_diff = rerand_Lp12_34_diff(find(isnan(rerand_Lp12_34_diff)==0));
    rerand_Cp12_34_diff = (rerand_Cp1-rerand_Cp2)-(rerand_Cp3-rerand_Cp4);
    rerand_Cp12_34_diff = rerand_Cp12_34_diff(find(isnan(rerand_Cp12_34_diff)==0));
    rerand_gE12_34_diff = (rerand_gE1-rerand_gE2) - (rerand_gE3-rerand_gE4);
    rerand_gE12_34_diff = rerand_gE12_34_diff(find(isnan(rerand_gE12_34_diff)==0));
    rerand_localE12_34_diff = (rerand_localE1-rerand_localE2)-(rerand_localE3-rerand_localE4);
    rerand_localE12_34_diff = rerand_localE12_34_diff(find(isnan(rerand_localE12_34_diff)==0));
% 
%      PathLen.Lp12_diff_z(m) = ...
%         ((PathLen.Lp1(m)- PathLen.Lp2(m)) - mean(rerand_Lp12_diff))/std(rerand_Lp12_diff);
%     ClustCoff.Cp12_diff_z(m) = ...
%         ((ClustCoff.Cp1(m)- ClustCoff.Cp2(m)) - mean(rerand_Cp12_diff))/std(rerand_Cp12_diff);
%     Eff.gE12_diff_z(m) = ...
%         ((Eff.gE1(m)- Eff.gE2(m)) - mean(rerand_gE12_diff))/std(rerand_gE12_diff);
%     Eff.localE12_diff_z(m) = ...
%         ((Eff.localE1(m)- Eff.localE2(m)) -
%         mean(rerand_localE12_diff))/std(rerand_localE12_diff);

    deltagE =  (Eff.gE1(m)- Eff.gE2(m)) - (Eff.gE3(m)- Eff.gE4(m));
    if deltagE >=0
        Eff.gE12_34_diff_p(m) = length(find(rerand_gE12_34_diff>deltagE))/(length(rerand_gE12_34_diff)+1);
    else
        Eff.gE12_34_diff_p(m) = length(find(rerand_gE12_34_diff<deltagE))/(length(rerand_gE12_34_diff)+1);
    end
    [sortmaxmingE12_34diff sortmaxmingE12_34diffindex] = sort(rerand_gE12_34_diff);
    Eff.upper95gE12_34diff (m) = sortmaxmingE12_34diff(ceil((num_rand+1)*0.05));
    Eff.lower95gE12_34diff (m) = sortmaxmingE12_34diff(end-ceil((num_rand+1)*0.05)-1);

    deltalocalE =  (Eff.localE1(m)- Eff.localE2(m))-(Eff.localE3(m)- Eff.localE4(m));
    if deltalocalE >=0
        Eff.localE12_34_diff_p(m) = length(find(rerand_localE12_34_diff>deltalocalE))/(length(rerand_localE12_34_diff)+1);
    else
        Eff.localE12_34_diff_p(m) = length(find(rerand_localE12_34_diff<deltalocalE))/(length(rerand_localE12_34_diff)+1);
    end
    [sortmaxminlocalE12_34diff sortmaxminlocalE12_34diffindex] = sort(rerand_localE12_34_diff);
    Eff.upper95localE12_34diff  (m) = sortmaxminlocalE12_34diff(ceil((num_rand+1)*0.05));
    Eff.lower95localE12_34diff  (m) = sortmaxminlocalE12_34diff(end-ceil((num_rand+1)*0.05)-1);

    deltaLp = (PathLen.Lp1(m) - PathLen.Lp2(m)) -(PathLen.Lp3(m) - PathLen.Lp4(m));
    if deltaLp >=0
        PathLen.Lp12_34_diff_p(m) = length(find(rerand_Lp12_34_diff>deltaLp))/(length(rerand_Lp12_34_diff)+1);
    else
        PathLen.Lp12_34_diff_p(m) = length(find(rerand_Lp12_34_diff<deltaLp))/(length(rerand_Lp12_34_diff)+1);
    end
    [sortmaxminLp12_34diff sortmaxminLp12_34diffindex] = sort(rerand_Lp12_34_diff);
    PathLen.lower95Lp12_34diff (m)= sortmaxminLp12_34diff(ceil((num_rand+1)*0.05));
    PathLen.upper95Lp12_34diff (m) = sortmaxminLp12_34diff(end-ceil((num_rand+1)*0.05)-1);

    deltaCp = (ClustCoff.Cp1(m) - ClustCoff.Cp2(m)) - (ClustCoff.Cp3(m) - ClustCoff.Cp4(m));
    if deltaCp >=0
        ClustCoff.Cp12_34_diff_p(m) = length(find(rerand_Cp12_34_diff>deltaCp))/(length(rerand_Cp12_34_diff)+1);
    else
        ClustCoff.Cp12_34_diff_p(m) = length(find(rerand_Cp12_34_diff<deltaCp))/(length(rerand_Cp12_34_diff)+1);
    end
    [sortmaxminCp12_34diff sortmaxminCp12_34diffindex] = sort(rerand_Cp12_34_diff);
    ClustCoff.lower95Cp12_34diff (m) = sortmaxminCp12_34diff(ceil((num_rand+1)*0.05));
    ClustCoff.upper95Cp12_34diff (m) = sortmaxminCp12_34diff(end-ceil((num_rand+1)*0.05)-1);

    rerand.Lp{m} =  rerand_Lp12_34_diff;
    rerand.Cp{m} =  rerand_Cp12_34_diff;
    rerand.gE{m} = rerand_gE12_34_diff;
    rerand.localE{m} = rerand_localE12_34_diff;

%     if brandnetwork ==1
% 
%         rerand_Lambda12_diff = rerand_Lambda1-rerand_Lambda2;
%         rerand_Lambda12_diff = rerand_Lambda12_diff(find(isnan(rerand_Lambda12_diff)==0));
%         rerand_Gamma12_diff = rerand_Gamma1-rerand_Gamma2;
%         rerand_Gamma12_diff = rerand_Gamma12_diff(find(isnan(rerand_Gamma12_diff)==0));
% % 
% %         PathLen.Lambda12_diff_z(m) = ...
% %             ((PathLen.Lambda1(m)- PathLen.Lambda2(m)) - mean(rerand_Lambda12_diff))/std(rerand_Lambda12_diff);
% %         ClustCoff.Gamma12_diff_z(m) = ...
% %             ((ClustCoff.Gamma1(m)- ClustCoff.Gamma2(m)) - mean(rerand_Gamma12_diff))/std(rerand_Gamma12_diff);
% 
%         deltaLambda = PathLen.Lambda1(m) - PathLen.Lambda2(m);
%         if deltaLp >=0
%             PathLen.Lambda12_diff_p(m) = length(find(rerand_Lambda12_diff>deltaLambda))/(length(rerand_Lambda12_diff)+1);
%         else
%             PathLen.Lambda12_diff_p(m) = length(find(rerand_Lambda12_diff<deltaLambda))/(length(rerand_Lambda12_diff)+1);
%         end
%         [sortmaxminLambda12diff sortmaxminLambda12diffdiffindex] = sort(rerand_Lambda12_diff);
%         PathLen.lower95Lambda12diff  (m) =  sortmaxminLambda12diff(ceil((num_rand+1)*0.05));
%         PathLen.upper95Lambda12diff  (m) =  sortmaxminLambda12diff(end-ceil((num_rand+1)*0.05)-1);
% 
%         deltaGamma = ClustCoff.Gamma1(m) - ClustCoff.Gamma2(m);
%         if deltaGamma >=0
%             ClustCoff.Gamma12_diff_p(m) = length(find(rerand_Gamma12_diff>deltaGamma))/(length(rerand_Gamma12_diff)+1);
%         else
%             ClustCoff.Gamma12_diff_p(m) = length(find(rerand_Gamma12_diff<deltaGamma))/(length(rerand_Gamma12_diff)+1);
%         end
%         [sortmaxminGamma12diff sortmaxminGamma12diffindex] = sort(rerand_Gamma12_diff);
%         ClustCoff.lower95Gamma12diff   (m) = sortmaxminGamma12diff(ceil((num_rand+1)*0.05));
%         ClustCoff.upper95Gamma12diff  (m) = sortmaxminGamma12diff(end-ceil((num_rand+1)*0.05)-1);
% 
%         rerand.Gamma{m}= rerand_Gamma12_diff;
%         rerand.Lambda{m} = rerand_Lambda12_diff;
%     end

end

