
function [auc] = gretna_sweff_auc(Rmatrix, s1,s2,deltas,type)

% function [auc] = gretna_sweff_auc(Rmatrix, s1,s2,deltas,type)
% example:
%  1. locE,gE
%  [auc] = gretna_sweff_auc(Rmatrix, 0.05,0.4,0.01,0)
% 2. locE,gE, locEratio, gEratio, swefficienyness
% [auc] = gretna_sweff_auc(Rmatrix, 0.05,0.4,0.01,1)
% Yong HE, BIC

thresh_s = s1:deltas:s2;

auc.thresh_s = thresh_s;

if type == 0 %Cp Lp
    for j =1:length(thresh_s)
        [bmatrix,r] = gretna_R2b(Rmatrix, 's',thresh_s(j));
        [eff] = gretna_efficiency(bmatrix);
        locE(j) = eff.locE;
        gE(j) = eff.gE;
    end
    auc.alocE =  (sum(locE) -  sum(locE([1 end]))/2)*deltas;
    auc.agE =  (sum(gE) -  sum(gE([1 end]))/2)*deltas;
    auc.locE = locE;
    auc.gE = gE;
end


if type == 1 %Cp Lp, gamma,lambda, sigma
    for j =1:length(thresh_s)
        [bmatrix,r] = gretna_R2b(Rmatrix, 's',thresh_s(j));
        [eff] = gretna_efficiency_sw(bmatrix,50);
        locE(j) = eff.locE;
        gE(j) = eff.gE;
        locEratio(j) = eff.locEratio;
        gEratio(j) = eff.gEratio;
        swefficienyness(j) = eff.swefficienyness;
    end
    auc.alocE =  (sum(locE) -  sum(locE([1 end]))/2)*deltas;
    auc.agE =  (sum(gE) -  sum(gE([1 end]))/2)*deltas;
    auc.alocEratio =  (sum(locEratio) -  sum(locEratio([1 end]))/2)*deltas;
    auc.agEratio =  (sum(gEratio) -  sum(gEratio([1 end]))/2)*deltas;
    auc.aswefficienyness =  (sum(swefficienyness) -  sum(swefficienyness([1 end]))/2)*deltas;
    auc.locE = locE;
    auc.gE = gE;
    auc.locEratio = locEratio;
    auc.gEratio = gEratio;
    auc.swefficienyness = swefficienyness;
end