
function [AIJ] = gretna_wTOM(RIJ)
% function [AIJ] = gretna_wTOM(RIJ)
%weighted
%Ravasz science 2002 297
% Zhang et al., 2005


%  RIJ = r.ct
RIJ = RIJ-diag(diag(RIJ));
N = size(RIJ,1);
AIJ = zeros(N,N);

sij = (abs(RIJ));


for i = 1:N-1
    for j = i+1:N
 
        x = sij(i,:); sx = sum(x); x(j) = 0;
        y = sij(j,:);  sy = sum(y);y(i) = 0;
        AIJ(i,j) = (sum(x.*y) + sij(i,j))/(min(sx,sy)+1-sij(i,j)) ;
    end
end
AIJ = AIJ + AIJ';

%
%
% %-------------------------------------------------------------------------
% %Clustering data using Hierarchical Clustering
%  AIJ = mall
% load original_labels.txt
% % original_labels = original_labels_aal;
% w = AIJ;
% D = 1-w;
% count = 1;
% for i = 1:size(w)
%     for j = i+1:size(w)
%         eucD (count) = D(i,j);
%         count = count + 1 ;
%     end
% end
% clustTreeEuc = linkage(eucD,'average');
%
% % The cophenetic correlation is one way to verify that the cluster tree
% % is consistent with the original distances. Large values indicate that
% % the tree fits the distances well, in the sense that pairwise linkages
% % between observations correlate with their actual pairwise distances.
% cophenet(clustTreeEuc,eucD)
% labels = {'SFG.R','SFG.L','MFG.R',' MFG.L','IFG.R',' IFG.L','MdFG.R','MdFG.L','PrCG.R','PrCG.L','LOFG.R','LOFG.L','MOFG.R','MOFG.L','SPL.R','SPL.L',...
%     'SMG.R','SMG.L','ANG.R','ANG.L','PCU.R','PCU.L','PoCG.R','PoCG.L','STG.R','STG.L','MTG.R','MTG.L','ITG.R','ITG.L','UNC.R','UNC.L','MOTG.R','MOTG.L',...
%     'LOTG.R','LOTG.L','PHG.R','PHG.L','OP.R','OP.L','SOG.R','SOG.L','MOG.R','MOG.L','IOG.R','IOG.L','CUN.R','CUN.L','LING.R','LING.L','CING.R','CING.L','INS.R','INS.L'};
% % To visualize the hierarchy of clusters, you can plot a dendrogram.
% figure;[h,nodes, perm] = dendrogram(clustTreeEuc,0,'orientation','right'  );
% set(gca,'TickDir','out','Fontsize',8,'FontWeight','bold','TickLength',[.002 0],'yTickLabel',labels(str2num(get(gca,'yticklabel'))));
% xlabel('Euclidean distances')
% perm2 = original_labels(perm');
% for i = 1:length(AIJ)
%     for j = 1:length(AIJ)
%         reorder(i,j) = AIJ(perm(i),perm(j));
%     end
% end
% imagesc(reorder)
% set(gca,'TickDir','out','Fontsize',8,'FontWeight','bold','TickLength',[.002 0],'yTickLabel',perm2(str2num(get(gca,'yticklabel'))));
% set(gca,'TickDir','out','Fontsize',8,'FontWeight','bold','TickLength',[.002 0],'xTickLabel',perm2(str2num(get(gca,'xticklabel'))));
%
%
