function [M] = mona_readvolume(sourcedir, IDfile, volumedir, prefix)

% *************************************************************************
% This function is used to read individual cortical thickness values
% typically obtained from the CIVET pipeline procedure (Claude's version).
%
%function [M] = mona_readvolume(sourcedir, IDfile, volumedir, prefix)
%  
%
 % Yong HE, BIC, MNI, McGill 2006/09/12
% ************************************************************************

 

 

subID = textread(IDfile, '%s');
Nsub = size(subID,1);

for i = 1:Nsub
    fprintf('.')	
    filename1 = strcat(strcat(strcat(prefix,'_'),subID{i}),'_masked.dat');
    filename = strcat(strcat(strcat(sourcedir,subID{i}), volumedir), filename1);
    M.Reg{i} = load(filename);
end


for i = 1:Nsub
    fprintf('.')	
    filename1 = strcat(strcat(strcat(prefix,'_'),subID{i}),'_cls_volumes.dat');
    filename = strcat(strcat(strcat(sourcedir,subID{i}), volumedir), filename1);
    M.Tot{i} = load(filename);
end


fprintf('Finished.\n')

