function  [lambda, D] = mona_shortestpathlength(A)
%  the average path length of graph G 
A = A + diag(diag(A));
A(find(A==0)) = inf;
N = length(A);
D = A - diag(diag(A));

% Floyd-Warshall algorithm 
for i = 1:N
  k = setdiff((1:N),i);
  D(k,k) = min(D(k,k),repmat(D(k,i),1,N-1) + repmat(D(i,k),N-1,1));
end

for i = 1:N
    D(i,i) =0;
end

D = triu(D);
lambda = sum(sum(D(D~=inf)))/(N*(N-1)/2);
D = D + D';

return