function R = randmiou_fullweighted_jc(R1)

%Undirected strongly-connected graph --> randomised undirected graph
%Each edge rewired ~ITER times; in/out degree and connectedness preserved
%Rewiring algorithm from Maslov and Sneppen (2002) Science 296:910
%
% Mika Rubinov, 2007
% =========================================================================


[rows, cols, vals]=find(tril(R1));
N=length(R1);
K = N*(N-1)/2;
%ITER=K*ITER;
%ITER = 2 * K;

% Network randomization method 1:
% The function is used to generate a random matrix with N nodes and K edges
% as the real network G.
%B = ones(N,N);
%B = B - diag(diag(B));
randp = randperm(N*(N-1)/2);

A = sparse(rows(randp(1:K)), cols(randp(1:K)),vals,N,N);
R = full(A) + full(A)';